' *************************************************************
'
'          Demo for using Mail Rules with VBA Script
'
'	It may do the next actions:
'		Show message body ( in NotePad )
'		Activate WEB ( if subject is 'http:XXXXXXX' )
'		Ftp ( if subject is 'ftp:XXXXXX' )
'
'		And then :
'		Move to folder
'		Forward
'		Delete message
'
' ************************************************************* 

'Global variables
'--------------------------
Dim Result As String
Dim FolderName As String
Dim Address As String
Dim FileName As String
Dim Subject As String
Dim Host As String
Dim UserId As String
Dim Password As String
Dim WebFlag as Integer
Dim FtpFlag as Integer

' Main Program :
' ------------------------
Sub Main 

' RUN this file only if it is running from the Mial rule action!!!!!
  If  NM_RUNASMAILRULE = 0 Then
	MsgBox "You must run this file from Mail application . Use mail rules to run this file ."
	return
  End If

' Define dialog that give the next options :
' Show message body ( always )
' Activate WEB ( if subject is started with 'http:.....' )
' Activate FTP ( if subject is started with 'ftp:.....' )
Begin Dialog OptionDialog 165, 64, 100, 123,  "Mail Rule Actions", .OptionFunction
	Text 8, 4, 90, 8, "You have got a new mail"
	GroupBox 8, 19, 80, 76, "Actions"	
	CheckBox 16, 32, 52, 12, "Show Body", .ShowBody
	CheckBox 16, 53, 52, 12, "Activate Web", .ActWeb
	CheckBox 16, 76, 52, 12, "Activate Ftp", .ActFtp
	OKButton   8, 103, 36, 12
	CancelButton 54, 103 ,36, 12
End Dialog


' Define dialog that give the next actions on message
' Move message to folder
' Forward the message
' Delete the message

Begin Dialog ActionDialog 165, 64, 100, 110, "Mail Message Action"
	OptionGroup .RadioGroup
		OptionButton 16, 20, 60, 8, "Move To Folder"
		OptionButton 16, 38, 60, 8, "Forward"
		OptionButton 16, 56, 60, 8, "Delete"
		OptionButton 16, 74, 60, 8, "Nothing"
	GroupBox 8, 4, 85, 85, "Actions on Mail Message"
	OKButton 8, 95, 36, 12
	CancelButton 54, 95, 36, 12
End Dialog

' Declare dialog variable
Dim OptDlg as OptionDialog
Dim ActDlg as ActionDialog

' consider if we can use WEB and FTP options
Subject = MailRuleGetFieldSubject()

If  Left( Subject , 5 ) = "http:" Then 
	WebFlag = 1
Else 
	WebFalg = 0
End If

If Left(Subject , 4) = "ftp:" Then 
	FtpFlag = 1
Else
	FtpFalg = 0
End If

' Activate first dialog	
Button = dialog ( Optdlg )

' Button = -1 if OK pressed,  Button = 0 if Cancel pressed
If Button = -1 Then    			' OK pressed 
	' Show checked body option 
	If Optdlg.ShowBody = 1 Then 
		Show_Body
	End If
	For i = 1 To 1000 
	Next i 
	' Activate Web option cheked
 	If OptDlg.ActWeb = 1 Then 
		Activate_Web
	End If
	For i = 1 To 1000 
	Next i
	' Activate Ftp  option cheked
	If OptDlg.ActFtp = 1 Then 
		Do_Ftp
	End If
	For i = 1 To 1000 
	Next i 
End If

' Activate second dialog
Button = Dialog ( ActDlg )

' Button = -1 if OK pressed,  Button = 0 if Cancel pressed
If Button = -1 Then
	Select Case ActDlg.RadioGroup
	Case 0  				' Move to folder choosen
		Move_To_Folder
	Case 1				' Forward choosen
		Forward_Message
	Case 2				' Delete message choosen
		Delete_Message
	End Select
End If
End Sub

'  Option Dialog Function
Function OptionFunction ( ControlID$, Action%, SuppValue% )
	Select Case Action%
		Case 1 				' Initialization
			If WebFlag = 0 Then 
				DlgEnable "ActWeb", 0
			Else
				DlgEnable "ActWeb" , 1
			End If 
			If FtpFlag = 0 Then
				DlgEnable "ActFtp", 0
			End If 
		End Select
	OptionFunction = 0
End Function


' User choose to see body of new message 
'-------------------------------------------------------------------
Sub Show_Body
	FileName = MailRuleGetFile()   	'get file name of new message to FileName

	rc = Shell ( "NotePad.exe" ,1 )  	' run NotePad
	SendKeys "%fo" , 1		' open file
	SendKeys FileName, 1    	' set name of opened file
	SendKeys  "{ENTER}"	
End Sub

' User choose activate WebSurfer
' Subject1 of the mail =  "http:xxxxxx"
'----------------------------------------------------------------
Sub Activate_Web
	Dim Url As String
	Dim i As Integer
	
	' Subject = 'http:XXXXXXX'
	Url = Right ( Subject , Len( Subject) - 5 )
	rc = Shell ( "Websurf.exe" ,1 )	
	SendKeys  "%rc"		  	' Cancel current Load
	SendKeys  "%rg"			' Go-To URL
	SendKeys  Url
	SendKeys  "{ENTER}" , 1
End_Web:
End Sub

' User choose FTP 
' Subject1 of the mail = ftp:xxxxxxxxxxxxx
'------------------------------------------------------------
Sub Do_Ftp
	Dim Temp As String

	UserName = "anonymous"
	Password = "pass"
	' subject = 'ftp:XXXXXXXX'
	Host = Right ( Subject , Len ( Subject ) - 4 )
	FTPConnect   Host ,  UserName ,  Password 
	If NM_ResultCode <> 0 Then 
		Print "Error in FTP"	
		Goto End_Ftp
	End If
End_Ftp:
End Sub


' User choose to move new mail to folder
'----------------------------------------------------------------
Sub Move_To_Folder
	Get_Move_Folder_dlg  	'get folder name to variable FoldreName
	MailRuleMoveToFolder FolderName
End Sub

' User choose to forward new mail
'------------------------------------------------------
Sub Forward_Message
	Forward_dlg	     	' get email address forward to
	MailRuleForward Address
End Sub

' User choose to delete new mail message
'------------------------------------------------------------------
Sub Delete_Message
	MailRuleDelete
End Sub

' Ask for folder for move to it the message
'------------------------------------------------------------
Sub Get_Move_Folder_dlg
DlgStart   
	DlgItemAsk  "Enter folder name" ,  FolderName ,  0 , 20 
	DlgInquire
	DlgGetItemValue 0, FolderName
DlgEnd	
End Sub

' Ask for email address for forward the message
'----------------------------------------------------------------------------
Sub Forward_dlg
DlgStart   
	DlgItemAsk  "Enter mail address (to forward)" ,  Address ,  0 , 20 
	DlgInquire
	DlgGetItemValue 0, FolderName
DlgEnd	
End Sub

