' telnet.vba
'
' A sample script for running Telnet emulation with VBA.
'
' Copyright (C) 1996 NetManage Inc.
' All rights reserved.
'
' This code may be renamed and modified for your own purposes.

' Global Values
'
Const conTitle = "Telnet Demo"          ' Title of dialog boxes
Const conLoginPrompt = "login:"         ' Default login prompt
Const conPwdPrompt = "Password:"        ' Default password prompt
Const conShellPrompt = "%"              ' Default shell prompt
Dim telnetTitle As String               ' Used to find Telnet window

' Main:
' This is the entry point of the script.
'
Sub Main
	' Local variables used in Main
	Dim hostName As String
	Dim userName As String
	Dim userPwd As String
	Dim loginPrompt As String
	Dim pwdPrompt As String
	Dim shellPrompt As String
	Dim row As Integer
	Dim col As Integer

	' Get the host values from a dialog, then connect to the host.
	loginPrompt = conLoginPrompt
	pwdPrompt = conPwdPrompt
	shellPrompt = conShellPrompt
	GetHostValues hostName, userName, userPwd, loginPrompt, _
	pwdPrompt, shellPrompt

	' Set Telnet as the active emulation, then connect to the host
	Emulation "Telnet"
	EMSetTelnet hostName, 23
	EMActivate "AA"

	' Save the title of the Telnet windows, bring the window to the
	' front.
	telnetTitle = "Telnet - " + hostName + " (AA)"
	AppActivate telnetTitle

	' Automatically logon to a remote host. It uses the host prompts
	' set by the end user in GetHostValues.
	DlgTitle "User Name"
	EMWaitText 30, loginPrompt, 1, 1, row, col
	If NM_ResultCode = VS_STRING_NOT_FOUND Then
		GoTo ErrorHandler
	End If
	EMSendKey userName
	EMSendKey "<RETURN>"
	DlgTitle "Password"
	EMWaitText 30, pwdPrompt, 1, 1, row, col
	If NM_ResultCode = VS_STRING_NOT_FOUND Then
		GoTo ErrorHandler
	End If
	EMSendKey userPwd
	EMSendKey "<RETURN>"

	' Call subroutine to do activity on the host.
	HostActivity

ErrorHandler:
	' Disconnect the Telnet session.
	EMDisconnect "AA" 
End Sub   

' HostActivity:
' Display and option of commands to send to the host. Terminate the
' session with the host when the user selects 'exit'. The VBA Dialog
' is used here.
'
Sub HostActivity()
	' Local variables used in HostActivity
	Dim row As Integer
	Dim col As Integer

	' Define a dialog box for user selected commands.
	Begin Dialog dlgCmds 0, 0, 170, 85, "Telnet Demo"
		Text 10, 5, 150, 10, "Choose a command to send to the host."
		OptionGroup .cmdOption
		OptionButton 20, 20, 54, 8, "ls -la"
		OptionButton 20, 30, 54, 8, "who"
		OptionButton 20, 40, 54, 8, "df"
		OptionButton 20, 50, 54, 8, "exit"
		OkButton 60, 66, 50, 14
	End Dialog
	Dim dlgCmds1 As dlgCmds

	' This loop terminites waits for a shell prompt and sends
	' a command selected by the end user.
	Do
		DlgTitle "Shell Prompt"
		EMWaitText 30, shellPrompt & " " , 1, 1, row, col
		If NM_ResultCode = VS_STRING_NOT_FOUND Then
			Exit Do
		End If
		Dialog dlgCmds1
		AppActivate telnetTitle
		Select Case dlgCmds1.cmdOption
			Case 0
				EMSendKey "ls -la<RETURN>"
			Case 1
				EMSendKey "who<RETURN>"
			Case 2
				EMSendKey "df<RETURN>"
			Case 3
				EMSendKey "exit<RETURN>"
				Exit Do
		End Select
	Loop
End Sub

' GetHostValues:
' Displays a dialog asking the user for values. The results
' get passed back to the calling routine through the argument
' list. The DlgStart/DlgEnd method of creating a dialog is
' used.
'
Sub GetHostValues(host$, userN$, userP$, loginP$, pwdP$, shellP$)
	' Local variables used in GetHostValues
	Dim val1 As String
	Dim val2 As String
	Dim val3 As String
	Dim val4 As String
	Dim val5 As String
	Dim val6 As String
	DlgStart
		' Setup the layout of the dialog
		DlgTitle conTitle
		DlgItemAsk "&Host Address:", "", 1, 25
		DlgItemAsk "   &User Name:", "", 2, 15
		DlgItemAskQuiet "     &Password:", "", 3, 15
		DlgItemType "Host Prompts:" 
		DlgItemAsk "U&ser", loginP$, 4, 8
		DlgItemSameLine
		DlgItemAsk "P&assword", pwdP$, 5, 8
		DlgItemSameLine
		DlgItemAsk "Sh&ell", shellP$, 6, 2
		' Loop until all required values are entered.
		Do
			' Display the dialog and wait
			DlgInquire
			' Read values from dialog fields
			DlgGetItemValue 1, val1
			DlgGetItemValue 2, val2
			DlgGetItemValue 3, val3
			DlgGetItemValue 4, val4
			DlgGetItemValue 5, val5
			DlgGetItemValue 6, val6
			If val1 = "" Or val3 = "" Then
				MsgBox "A user name and host address are required."
			Else
				Exit Do
			End If
		Loop
	DlgEnd
	host$ = val1
	userN$ = val2
	userP$ = val3
	loginP$ = val4
	pwdP$ = val5
	shellP$ = val6
End Sub
